
public class Recursive {

    public static long recursiveFactorial(long n){
	if (n==0) return 1;
	else return n*recursiveFactorial(n-1); //recursive case	
    }
	
    /**non-recursive version*/
    public static long factorial(int n){
	long fact=1;
	int i=1;
	while(i<=n) {fact=fact*i; i+=1;}
	return fact;
    }

    public static String convert(String s){
	int len=s.length();
	if (s.length()<=3) return s;
	else{
	    return (convert(s.substring(0,len-3)) + "," + 
		    s.substring(len-3,len));
	}
    }
	
	
    // ruler example from GoTa p.136
	
    public static void drawOneTick(int tickLength){//draw a tick with no label
	drawOneTick(tickLength,-1);}
	
    public static void drawOneTick(int tickLength, int tickLabel){//draw one tick
	for (int i=0;i<tickLength; i++) System.out.print("-");
	if (tickLabel>=0) System.out.print(" " +tickLabel);
	System.out.print("\n");
    }
	
    public static void drawTicks(int tickLength){ //draw ticks of given length
	if (tickLength>0){ //stop when length drops to 0
	    drawTicks(tickLength-1); //recursively draw left ticks
	    drawOneTick(tickLength); //draw center tick
	    drawTicks(tickLength-1); //recursively draw right ticks
	}
    }
    
    public static void drawRuler(int ninches, int majorLength){//draw ruler
	drawOneTick(majorLength,0);
	for (int i =1; i<=ninches;i++){
	    drawTicks(majorLength-1);   //draw ticks for this inch
	    drawOneTick(majorLength,i); //draw tick i and its label
	    
	}
    }


    //
    // reverse an array
    //

    public static void swap(int[] A, int i, int j){
	int temp = A[i]; A[i] = A[j]; A[j]  =temp;
    }

    public static void reverse(int[] A,int lwb,int upb){
	if (lwb < upb ){
	    swap(A,lwb,upb);
	    reverse(A,lwb+1,upb-1);
	}
    }

    public static void iterReverse(int[] A,int lwb,int upb){
	while (lwb < upb){
	    swap(A,lwb,upb);
	    lwb++;
	    upb--;
	}
    }

	
    public static long binaryFib(long n){
	if (n<=1) return n; else return (binaryFib(n-1)+binaryFib(n-2));
    }
    
    public static int raisePower(int m, int n){
	if (n==0) return 1;
	else return(m*raisePower(m,n-1));
    }
    /**recursive method to determine whether an integer n has a 9
     * amongst its digits
     */
    public static boolean has9(int n){
	if (n%10==9) return true;
	else return((n>10)&&has9(n/10));
    }
	
    /** recursive method to reverse a string between positions 
     * x and y
     */
    public static String flip(String s, int x, int y){
	if (y-x==0) return ("" + s.charAt(x));
	else return flip(s,x+1,y)+s.charAt(x);
    }
    
    /**recursive method to print binary representation of integer 
     * to standard output
     */
    public static void writeBinary(int n){
	if(n<2) System.out.print(n);
	else{
	    writeBinary(n/2);
	    System.out.print(n%2);
	}
    }
	
    
    //
    // binary search
    //

    public static int binarySearch(String[] A,String s){
	return binarySearch(A,0,A.length-1,s);
    }

    public static int binarySearch(String[] A,int lwb, int upb, String s){
	if(lwb > upb) return -1;
	int mid = (lwb + upb)/2;
	int comparison = s.compareTo(A[mid]);
	if (comparison == 0) return mid;
	if (comparison < 0) return binarySearch(A,lwb,mid-1,s);
	else return binarySearch(A,mid+1,upb,s);
    }


    //
    // permutations of a string
    //

    
    public static void perm(String s){perm("",s);}
    
    private static void perm(String s1,String s2){
	int n = s2.length();
	if (n == 0) System.out.println(s1);
	else for (int i=0;i<n;i++) perm(s1 + s2.charAt(i),s2.substring(0,i) + s2.substring(i+1,n));
    }

    public static int M(int n){
	//System.out.println("M("+ n +")");
	if (n > 100) return n-10;
	else return M(M(n+11));
    }
   //
    // McCarthy's 91 function
    // returns 91 for n <= 101
    //
}
