import java.util.*;

public class Sets {
	

    public static boolean subset(HashSet a,HashSet b){
	Iterator it = a.iterator();
	while (it.hasNext()) if (!b.contains(it.next())) return false;
	return true;
    }

    public static boolean equals(HashSet a,HashSet b){
	return subset(a,b) && subset(b,a);
    }

    public static HashSet union(HashSet a,HashSet b){
	HashSet  c  = (HashSet)a.clone();
	Iterator it = b.iterator();
	while (it.hasNext()) c.add(it.next());
	return c;
    }

    public static HashSet intersection(HashSet a,HashSet b){
	HashSet  c  = new HashSet();
	Iterator it = a.iterator();
	while (it.hasNext()){
	    Object x = it.next();
	    if (b.contains(x))
		c.add(x);
	}
	return c;
    }

    public static HashSet setDifference(HashSet a,HashSet b){
	HashSet  c  = new HashSet();
	Iterator it = a.iterator();
	while (it.hasNext()){
	    Object x = it.next();
	    if (!b.contains(x))
		c.add(x);
	}
	return c;
    }

    public static HashSet symmetricDifference(HashSet a,HashSet b){
	return union(setDifference(a,b),setDifference(b,a));
    }

    public static Object select(HashSet a){
	Iterator it = a.iterator();
	return it.next();
    }

     public static HashSet PS(HashSet b){
	HashSet a = new HashSet();
	HashSet result = new HashSet();
	PS(a,b,result);
	return result;
    }
    //
    // result is the set of sets that is the powerset of a
    //

    private static void PS(HashSet a,HashSet b,HashSet result){
	//System.out.println("PS("+ a +","+ b +","+ result +")");
	if (b.isEmpty()) result.add(a);
	else {
	    Object x = select(b);
	    HashSet aPrime = (HashSet)a.clone();
	    HashSet bPrime = (HashSet)b.clone();
	    aPrime.add(x); bPrime.remove(x);
	    PS(aPrime,bPrime,result); PS(a,bPrime,result);
	}
    }
    //
    // take: take an element out of b, add it to a, then recurse
    // don't take: take an element out of b, do not add it to a, then recurse
    // Can be thought of as a binary tree with left branch "take" and
    // right branch "don't take"
    // This is a model for many algorithms, for example knapsack problem
    //
	
    public static void main(String[] args) throws Exception {
	
	String commands = "\nPaddy's amazing set functions (version 2.7182) \n" +
	    "add (+), powerset (ps), help, quit (q)";
	
	HashSet S = new HashSet();
	
	System.out.println(commands);
	Scanner sc = new Scanner(System.in);
	
	System.out.print("> ");
	String command = sc.next();
	
	while (!command.equals("quit") && !command.equals("q")){
	    
	    if (command.equals("help")) System.out.println(commands);
	    
	    if (command.equals("add") || command.equals("+")){
		System.out.print(">> ");
		String s = sc.next();
		S.add(s);
		System.out.println(S);
	    }
	    
	    if (command.equals("powerset") || command.equals("ps"))
		System.out.println(PS(S));
	    
	    System.out.print("> ");
	command = sc.next();
	}
    }
}
